def lunar_sum(a, b):
    """Calculates the lunar sum of two numbers."""
    a_str = str(a)
    b_str = str(b)
    max_len = max(len(a_str), len(b_str))
    a_str = a_str.zfill(max_len)  # Pad with leading zeros if necessary
    b_str = b_str.zfill(max_len)
    result = ""
    for i in range(max_len):
        result += str(max(int(a_str[i]), int(b_str[i])))
    return int(result)


def lunar_product(a, b):
    """Calculates the lunar product of two numbers."""
    a_str = str(a)
    b_str = str(b)
    result = ""
    for digit_a in a_str:
        row_result = ""
        for digit_b in b_str:
            row_result += str(min(int(digit_a), int(digit_b)))
        result += row_result + " "

    parts = result.split()
    num_parts = len(parts)

    final_result = ""
    for i in range(len(parts[0])):
        min_digit = min(int(part[i]) for part in parts)
        final_result += str(min_digit)
    return int(final_result)


a = int(input())
b = int(input())

lunar_sum_result = lunar_sum(a, b)
lunar_product_result = lunar_product(a, b)

print(lunar_sum_result, lunar_product_result)
