from collections import deque, defaultdict


def bfs(start, max_distance, graph):
    visited = set()
    queue = deque([(start, 0)])
    visited.add(start)

    while queue:
        node, distance = queue.popleft()

        if distance < max_distance:
            for neighbor in graph[node]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))

    return visited


def main():
    n, m, k = map(int, input().split())

    graph = defaultdict(list)

    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)

    protected_warehouses = set()

    for _ in range(k):
        p, h = map(int, input().split())
        reachable_warehouses = bfs(p, h, graph)
        protected_warehouses.update(reachable_warehouses)

    protected_warehouses = sorted(protected_warehouses)

    print(len(protected_warehouses))
    if protected_warehouses:
        print(" ".join(map(str, protected_warehouses)))
    else:
        print()


if __name__ == "__main__":
    main()