from collections import deque, defaultdict


def bfs(start, max_distance, graph):
    visited = set()
    queue = deque([(start, 0)]) 

    while queue:
        current, distance = queue.popleft()

        if distance < max_distance:
            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))

    return visited


def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    n, m, k = map(int, data[0].split())

    graph = defaultdict(list)

    for i in range(1, m + 1):
        a, b = map(int, data[i].split())
        graph[a].append(b)
        graph[b].append(a)

    protected_stores = set()

    for i in range(m + 1, m + k + 1):
        p, h = map(int, data[i].split())
        protected_stores.update(bfs(p, h, graph))

    # Подготовка вывода
    protected_stores = sorted(protected_stores)

    print(len(protected_stores))
    print(" ".join(map(str, protected_stores)))


if __name__ == "__main__":
    main()