from collections import deque, defaultdict

def find_guarded_warehouses(n, m, k, roads, guards):
    # Создаем граф
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    # Для каждого охранника выполняем BFS
    for p, h in guards:
        queue = deque([(p, 0)])  # (текущий склад, текущее расстояние)
        visited = set([p])

        while queue:
            current_warehouse, current_distance = queue.popleft()
            guarded.add(current_warehouse)

            if current_distance < h:
                for neighbor in graph[current_warehouse]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, current_distance + 1))

    guarded_list = sorted(guarded)
    return len(guarded_list), guarded_list

# Чтение входных данных
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

# Вычисление результатов
count, guarded_warehouses = find_guarded_warehouses(n, m, k, roads, guards)

# Вывод результата
print(count)
if count > 0:
    print(" ".join(map(str, guarded_warehouses)))
else:
    print()